#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double T;

T eps = 0.0001;

struct Vec2{
	T x, y;
};


template <class Vec> 
inline T len(const Vec &v){
	
	return sqrtl(dot(v, v));
}

template <class Vec>
inline T len2(const Vec &v){

	return dot(v, v);
}

template <class Vec>
	inline Vec normalize(const Vec &v) {
		return v / len(v);
	}


inline Vec2 operator+(const Vec2 &a, const Vec2 &b){
	
	return {a.x + b.x, a.y + b.y};
}

inline Vec2 operator-(const Vec2 &a, const Vec2 &b){
	
	return {a.x - b.x, a.y - b.y};
}


inline Vec2 operator/(const Vec2 &a, const T &b){

	return {a.x / b, a.y / b};
}

inline Vec2 operator*(const Vec2 &a, const T &b){

	return {a.x * b, a.y * b};
}

inline T dot(const Vec2 &a, const Vec2 &b){
	
	return a.x * b.x + a.y * b.y;
}

inline T prod(const Vec2 &a, const Vec2 &b){
	
	return a.x * b.y - a.y * b.x;
}

int main(){
	ios_base::sync_with_stdio(0);
	
	//cout<<fixed<<setprecision(9);

	int N;
	T R, A, B;
	
	cin>>N>>R>>A>>B;
	
	Vec2 prost;
	prost.x=A;
	prost.y=B;
	prost = normalize(prost);
	R += eps/2;
	
	vector <pair <T, bool> > X;
	
	for(int i = 0; i < N;++i){
		Vec2 boat;
		cin>>boat.x;
		cin>>boat.y;
		
		T rzut = dot(prost, boat);
		Vec2 boat_prost = prost * rzut;
		Vec2 vodl       = boat  - boat_prost;
		
		T odl2  = len2(vodl);
		T dist2 = R * R - odl2;
		//cout<<"R*R: "<<R*R<<", odl2: "<<odl2<<endl;
		if(dist2 < eps / 1000.0) continue;
		//cout<<"dist2: "<<dist2<<endl;
		
		
		//cout<<"rzut: "<<rzut<<endl;
		
		X.push_back({rzut - sqrtl(dist2), true});
		X.push_back({rzut + sqrtl(dist2), false});
		
	}
	

	sort(X.begin(), X.end());
	
	/*/cout << "X: " << endl;
	for (auto e : X){
		cout << e.first << " " << e.second << endl;
	}/*/
	
	int ans = 0, buf = 0;
	
	for (auto e : X){
		buf += (e.second == true);
		buf -= (e.second == false);
		ans = max(ans, buf);
	}
	cout << ans << endl;
	
	return 0;
}
